/*
 *	fram.c
 *
 *	M62vC[
 *
 *	* Sat Feb 07 06:00:00 JST 2004 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

void
m6803_write(M6800* m6803, unsigned short addr, unsigned char data)
{
	DRIVER* driver = (DRIVER*)m6803;
	unsigned char* mem = driver->mem;
	AY38910* ay1;
	AY38910* ay2;

	switch(addr) {
	case 2:
		driver->port1 = data;
		return;
	case 3:
		/* Port2bit0Hi=>LoɂȂuԂɁAHiƂ̃rbgIŏo͂܂B */
		if((driver->port2 & 1) && !(data & 1)) {
			ay1 = &driver->ay1;
			ay2 = &driver->ay2;
			if(driver->port2 & 0x04) {
				if(driver->port2 & 0x08) ay38910_address(ay1, driver->port1);
				if(driver->port2 & 0x10) ay38910_address(ay2, driver->port1);
			} else {
				if(driver->port2 & 0x08) ay38910_write(ay1, driver->port1);
				if(driver->port2 & 0x10) ay38910_write(ay2, driver->port1);
			}
		}
		driver->port2 = data;
		return;
	}

	mem[addr] = data; /* o͏IĂXV!! */
}

void
ay38910_mix12(DRIVER* driver, short wbuff[], int count)
{
	AY38910* ay1 = &driver->ay1;
	AY38910* ay2 = &driver->ay2;
	//
	DDA clock_progress;
	int cycle;
	int sample;

	clock_progress = ay1->clock_progress; /* ̂߁Aꎞo */
	while(count > 0) {
		/* o߃TCN߂܂B */
		cycle = clock_progress.u;
		clock_progress.d += clock_progress.n;
		if(clock_progress.d >= 0) {
			clock_progress.d -= SPEAKER_FREQUENCY;
			cycle++;
		}

		/* 1Tv~LVO܂B */
		sample = ay38910_process(ay1, cycle)	/*  t7.5bit */
		       + ay38910_process(ay2, cycle);	/* +t7.5bit */
							/* =t8.5bitAۂɂ͓ɖ邱Ƃ͂Ȃł */

		sample <<= 16 - 6/**/;

		/* NbsOĊi[܂B */
		if(sample < -0x7fff) sample = -0x7fff;
		if(sample >  0x7fff) sample =  0x7fff;
		*wbuff++ = sample;

		/* cTv炵܂B */
		count--;
	}
	ay1->clock_progress = clock_progress; /* ߂BYꂸȂ!! */
}
